<script lang="ts" setup>
import PlayButton from '~/assets/icons/play-button.vue';
import { PlayCircleOutline } from 'slippers-ui/icons';
import type { BaseHero, BaseCard, BaseImage, BaseVideo } from '@/types/base';

interface HeroProps {
  hero: BaseHero;
  video?: BaseVideo;
  backgroundImage?: BaseImage;
  cards?: BaseCard[];
  config?: {
    highlightText: boolean;
  };
}

defineProps<HeroProps>();
const modalOpen = ref(false);
const openModal = () => {
  modalOpen.value = true;
};
const closeModal = () => {
  modalOpen.value = false;
};
</script>

<template>
  <section
    class="hero"
    :class="[{ 'has-backgroundImage': backgroundImage }]"
    :style="{ backgroundImage: backgroundImage ? `url(${backgroundImage.config.src})` : '' }"
  >
    <SlpContainer>
      <SlpRow class="wrapper">
        <SlpColumn v-if="backgroundImage" :cols="9" size="md" class="content">
          <div data-aos="fade-down" data-aos-duration="1600" data-aos-offset="0">
            <SlpTypography
              variant="display1"
              tag="h1"
              class="title slp-mb-24"
              :class="{ 'title--highlighted': config?.highlightText }"
            >
              {{ hero.titleHighlight }}
            </SlpTypography>
            <div class="hero__buttons" role="group" aria-label="buttons">
              <SlpButton
                v-if="hero.secondaryButton"
                variant="tertiary"
                class="secondary-button slp-mt-24"
                :data-ga-name="hero.secondaryButton.config.dataGaName"
                :data-ga-location="hero.secondaryButton.config.dataGaLocation"
                @click="openModal"
              >
                {{ hero.secondaryButton.text }}
                <SlpIcon :icon="PlayCircleOutline" size="md" />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <Teleport to="body">
      <CommonVideoModal v-if="video" :visible="modalOpen" @close="closeModal">
        <template #body>
          <CommonVideo :video-src="video.config.videoUrl" class="video" :thumbnail-src="video.config.videoThumbnail">
            <template #customPlayButton>
              <div class="vimeo-play-button">
                <PlayButton />
              </div>
            </template>
          </CommonVideo>
        </template>
      </CommonVideoModal>
    </Teleport>
  </section>
</template>

<style lang="scss" scoped>
.hero {
  position: relative;
}
.has-backgroundImage {
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;

  .content {
    padding: $spacing-64 0;
    z-index: 1;
    height: 100%;
    min-height: 100%;
    width: 100%;
    position: relative;

    @media (width > $breakpoint-md) {
      padding: 128px 0;
    }

    @media (max-width: $breakpoint-lg) {
      flex: 1 1 100%;
      width: 100%;
    }
  }

  .title {
    padding-bottom: $spacing-8;
    color: $color-primary-300;

    @media (min-width: 577px) and (max-width: 1029px) {
      font-size: 70px;
      line-height: 80px;
    }

    &--highlighted {
      background: linear-gradient(90deg, #e2b6f1 0%, #7759c2 100%);
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
      background-clip: text;
      color: transparent;
    }
  }
  .secondary-button {
    color: $color-text-50;
    padding: $spacing-8 $spacing-16;
    border: 2px solid transparent;
    background:
      linear-gradient($color-primary-200, $color-primary-200) padding-box,
      linear-gradient(159.09deg, #f6cdbe 0.37%, #f8f5ff 22.79%, #ffffff 44.56%, #e2d2f1 78.43%, #ffd4d8 109.47%)
        border-box;

    @media (width < $breakpoint-md) {
      width: 100%;
    }

    &:hover {
      text-decoration: underline;

      svg {
        transition: transform 0.4s ease;
        transform: translateX($spacing-8);
      }
    }

    svg {
      margin-left: $spacing-8;
    }
  }
}
.vimeo-play-button {
  position: absolute;
  left: 45%;
  top: 43%;
  background: #ffffff;
  transition: 0.15s;
  padding: 8px 24px;
  color: #171321;
  border-radius: 4px;
  width: 88px;
  height: 56px;
  display: flex;
  justify-content: center;
  align-items: center;
  @media (max-width: $breakpoint-sm) {
    left: 40%;
    top: 38%;
    width: 70px;
    height: 46px;
  }
}

.video:hover {
  .vimeo-play-button {
    background: #e8e7eb;
  }
}
</style>
